/*
 * (c) UQLX - see COPYRIGHT
 */



/*#include "QLtypes.h"*/
#include "QL68000.h"

#include <sys/types.h>
#ifndef __EMX__
#include <sys/mman.h>
#endif
#include <sys/stat.h>
#include <sys/time.h>
#include <time.h>

#include <fcntl.h> 
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#ifdef __EMX__
#define INCL_DOSPROCESS
#include <os2emx.h>
void dotime(void *);
#endif


#include "xcodes.h"  
#include "QL_config.h" 
#include "QInstAddr.h"


#if defined(VM_SCR) || defined(USE_VM)
#include "vm.h"
#endif

#include "unix.h"
#include "boot.h"

#define TIME_DIFF    283996800
void GetDateTime(w32 *);
long long qlClock=0;

#ifdef VTIME 
int qlttc=50;
int qltime=0;
int qitc=10;
#endif

int ux_boot=0;
int ux_bfd=0;
char *ux_bname="";
int start_iconic=0;
char *pwindow = NULL;
int is_patching=0;
int UQLX_optind;
int UQLX_argc;
char **UQLX_argv;

extern uw32 rtop_hard;
extern int screen_drawable;
extern jg_display_mode;
int do_update=0;  /* initial delay for screen drawing */

#define min(_a_,_b_) (_a_<_b_ ? _a_ : _b_)
#define max(_a_,_b_) (_a_>_b_ ? _a_ : _b_)

int rx1,rx2,ry1,ry2,finishflag,doscreenflush;
int QLdone=0;

#ifdef __EMX__ /*philip*/
int timerthread;
#endif


extern void FlushDisplay(void);

extern void DbgInfo(void);

#ifdef AUTO_BOOT
void btrap3(void);
#endif

extern void SchedulerCmd(void);
extern void KbdCmd(void);


#ifndef XAW
extern void process_events(void);
#endif

int script=0;
int redir_std=0;

int scrcnt=0;
volatile int doPoll=0;
#ifdef VTIME
volatile poll_req=0;   /* debug only */
#endif
int noints=0;
int schedCount=0;
extern int min_idle;
int HasDialog;

/* define useful values for pagesize */
#if defined(VM_SCR) || defined(USE_VM)
#else
long pagesize=RM_PAGESIZE;
int pageshift=RM_SHIFT;
#endif


int InitDialog()
{
  if (pwindow==NULL)
    {
      char buf[PATH_MAX],arg[100];
      char *p;
      int QMpid,bfpid;
      
#ifdef XAW
      return 0;
#else

      QMpid=getpid();
      sprintf(arg,"%d",QMpid);

      strncpy(buf,IMPL,PATH_MAX); 
      p=buf+strlen(buf)-1;
      if (*p!='/') 
	strncat(buf,"/",PATH_MAX);
#ifndef USE_IPC
      strncat(buf,"ButtonFrame",PATH_MAX);
#else
      strncat(buf,"Xgui",PATH_MAX);
#endif

      if ( access(buf, R_OK|X_OK)) return;

      bfpid=fork();
      if (bfpid) return bfpid;
  

      execl(buf,buf,arg,NULL);
      perror("Sorry, could not exec() GUI");
      /*kill(QMpid,SIGUSR1);*/
      _exit(0);
#endif
    }
}

int rtc_emu_on=0;
void prep_rtc_emu()
{
#ifdef USE_VM
 rtc_emu_on=1;
 mprotect((Ptr)theROM+0x18000,pagesize,PROT_NONE);
#endif
}
void set_rtc_emu()
{
#ifdef USE_VM
  uw32 t;
  
  rtc_emu_on=0;
  GetDateTime(&t);
  mprotect((Ptr)theROM+0x18000,pagesize,PROT_READ | PROT_WRITE);
  WL((Ptr)theROM+0x18000,t);
  *(unsigned char *)(theROM+0x18063)=(jg_display_mode==4 ? 0 : 8);
  mprotect((Ptr)theROM+0x18000,pagesize,is_patching ? PROT_NONE : PROT_READ);
#endif
}


uw16 sysvar_w(uw32 a)
{
  return RW((Ptr)theROM+0x28000+a);
}
uw32 sysvar_l(uw32 a)
{
  return RL((Ptr)theROM+0x28000+a);
}

/* restore mprotect() for area according to RamMap */
void uqlx_prestore(unsigned long start, unsigned long len)
{
#if defined(USE_VM) || defined(VM_SCR)
  int i,tmp,prot;

  for (i = start>>pageshift; (start+len) > (i<<pageshift); i++) 
    {
      switch(RamMap[i])
	{
	case QX_NONE: prot=PROT_READ; break;
	case QX_ROM:  prot=PROT_READ; break;
	  /*case QX_QXM:  prot=PROT_READ; break;*/
	case QX_RAM:  prot=PROT_READ|PROT_WRITE; break;
	case QX_SCR:  
	  if (!scrModTable[i-(qlscreen.qm_lo>>pageshift)] && do_update)
	    prot=PROT_READ; 
	  else prot=PROT_READ|PROT_WRITE;
	  break;
	case QX_IO:   prot=is_patching ? PROT_NONE : PROT_READ; break;
	default: printf("illegal value in uqlx_protect\n");
	}
      if (MPROTECT((Ptr)theROM+start,len,prot))
	{
	  perror("could not change VM permission");
	  printf("  at ql-addr %x, len %x, protection %x \n",start,len,prot);
	}
    }
#endif
}

/* set both RamMap and mprotect() */
void uqlx_protect(unsigned long  start, unsigned long len, int type)
{
  int i,tmp;

  /*printf("uqlx_protect %x, %x, %x\n",start,len,type);*/
  
#if defined(USE_VM) || defined(VM_SCR)
  if (type == QX_SCR) tmp=QX_RAM;
  else tmp=type;
#else
  tmp=type;
#endif

  /*printf("entering uqlx_protect %d %d %d\n %d, %d",start,len,type,
    start>>pageshift,start+len);*/
  for (i = start>>pageshift; (start+len) > (i<<pageshift); i++) 
    {
      /*printf("%d,%d,%d\n",start+len,i,start+(i<<pageshift));*/
      RamMap[i]=type;
    }
#if defined(USE_VM) || defined(VM_SCR)
  {
    int prot=0;
    switch (tmp) 
      {
      case QX_NONE: prot=PROT_READ; break;
      case QX_ROM:  prot=PROT_READ; break;
	/*case QX_QXM:  prot=PROT_READ; break;*/
      case QX_RAM:  prot=PROT_READ|PROT_WRITE; break;
	/*case QX_SCR:  prot=PROT_READ; break;*/
      case QX_IO:   prot=is_patching ? PROT_NONE : PROT_READ; break;
      default: printf("illegal value in uqlx_protect\n");
	  }
    if (MPROTECT((Ptr)theROM+start,len,prot))
      perror("could not change VM permission");
  }
#endif
}

#ifdef SHOWINTS
static long alrm_count=0;
static long a_ticks=0;
static long aa_cnt=0;
#endif

static int flptest=0;

void dosignal()
{
  uw32 t;
  
  doPoll=0;

#if 0 /*VTIME*/
  if (poll_req>1)
    printf("poll_req=%d in dosignal()\n",poll_req);
#endif
  

#ifndef XAW
  if (!script && !QLdone)
    process_events();
#endif

#ifdef SHOWINTS
  aa_cnt+=alrm_count;
  alrm_count=0;
  if (++a_ticks>49)
    {
      printf("received %d alarm signals, processed %d\n",aa_cnt,a_ticks);
      a_ticks=aa_cnt=0;
    }
#endif
    
  if(--scrcnt<0)
    {
      scrcnt=5;  /* update screen at least every so much ticks */
      doscreenflush=1;

#if 1
      set_rtc_emu();
#else 
      mprotect((Ptr)theROM+0x18000,pagesize,PROT_READ | PROT_WRITE);
      GetDateTime(&t);
      /*WriteByte(0x18021,theInt);*/
      WL((Ptr)theROM+0x18000,t);
      mprotect((Ptr)theROM+0x18000,pagesize,PROT_NONE);
#endif
    }

  if (flptest++>25)
    {
      flptest=0;
      TestCloseDevs();
      process_ipc();
    }
  
#if 0
  pendingInterrupt=2; /* cause 50 Hz interrupt */
  theInt=1<<(7-4);
  extraFlag=true;
  nInst2=nInst;
  nInst=0;
#else
#ifndef xx_VTIME
  FrameInt(); 
#endif
#endif
}

extern int xbreak;
void cleanup(int err)
{
#ifndef XAW
  if(HasDialog>0)
    kill(HasDialog,SIGINT);

  cleanup_ipc();
  if (!script && !xbreak)
    x_screen_close();
#endif
  CleanRAMDev("RAM");
  exit(err);
}



void oncc(int sig)
{
  printf("exiting\n");
  QLdone=1;
}

void signalTimer()
{
  doPoll=1;
#ifdef VTIME
  poll_req++;
#endif
  schedCount=0;
  /*if (nInst>10) nInst=10;*/
#ifdef SHOWINTS
  alrm_count++;
#endif
}


#if 1 /* ndef XAW */
void ontsignal(int sig)
{
  /*set_rtc_emu();*/   /* .. not yet working */
  signalTimer();
}
#endif

/* rather crude but reliable */
static fat_int_called=0;

void on_fat_int(int x)
{
    printf ("Terminate on signal %d\n", x);
    printf ("This may be due to an internal error,\n"
	    "a feature not emulated or an 68000 exception\n"
	    "that typically occurs only when QDOS is unrecoverably\n"
	    "out of control\n");
    dbginfo("FATAL error, PC may not be displayed correctly\n");

    if (fat_int_called==1) exit(2);
    if (fat_int_called>1) _exit(2);
    fat_int_called++;
    cleanup(1);
}


void init_timers()
{
#ifndef __EMX__
  struct itimerval val;
#endif

#ifndef VTIME   
#ifndef __EMX__ 
  val.it_value.tv_sec=0L;
  val.it_value.tv_usec=20000;
  
  val.it_interval=val.it_value;

#if 0/* defined( __linux__ ) && !defined(XAW)*/
  setitimer(ITIMER_PROF,&val,NULL);
#endif
  setitimer(ITIMER_REAL,&val,NULL);
#else /* EMX */
  timerthread=_beginthread(dotime,NULL,32767,NULL);
  DosSetPriority(PRTYS_THREAD,PRTYC_FOREGROUNDSERVER,PRTYD_MAXIMUM,timerthread);
#endif
#endif
}

void InitDialogErr(int x)
{
  HasDialog=-1;
  /* init_timers(); */
}

#ifdef __EMX__ /*philip*/
void dotime(void *x)
{
  while(1)
  {
    _sleep2(20);
    signalTimer();
  }
}
#endif

void init_signals()
{
  struct sigaction sac;
  long i;

  sigemptyset(&(sac.sa_mask));
#ifndef SUNOS
  sac.sa_flags=SA_NODEFER;
#endif

  for(i=1; i<=SIGUSR2;i++)
    {
      sac.sa_handler=oncc;
      sigaction(i,&sac,NULL);
    }
  sac.sa_handler=SIG_IGN;
  sigaction(SIGPIPE,&sac,NULL);

#if 1 /*ndef XAW*/
  sac.sa_handler=ontsignal;
#else 
  sac.sa_handler=signalTimer;
#endif
#if 0 /* defined(__linux__) && !defined(XAW) */
  sigaction(SIGPROF,&sac,NULL);  
#endif
  sigaction(SIGALRM,&sac,NULL);


#ifndef NSIG
#define NSIG _NSIG
#endif


  sac.sa_handler=on_fat_int;
  sigaction(SIGSEGV,&sac,NULL);
  sigaction(SIGBUS,&sac,NULL);
  sigaction(SIGILL,&sac,NULL);
  sigaction(SIGQUIT,&sac,NULL);

  sac.sa_handler=InitDialogErr;
  if (sigaction(SIGUSR1,&sac,NULL))
    perror("could not redefine SIGUSR1\n");

#if defined(VM_SCR) || defined(USE_VM)
#ifdef SPARC
  sac.sa_sigaction=segv_handler;  /* SUN seem to be the only to do this..*/
#else
  sac.sa_handler=segv_handler;  
#endif

#ifdef SPARC
  sac.sa_flags=SA_SIGINFO;
#endif
  sigaction(SIGSEGV,&sac,NULL);
#ifdef SPARC
  sac.sa_sigaction=buserr_handler;
#else
  sac.sa_handler=buserr_handler;
#endif
  sigaction(SIGBUS,&sac,NULL);
#endif
}



int load_rom(char *,w32);


void ChangedMemory(int from, int to)
{
  int i;
  uw32 dto,dfrom;

  if ((from>=qlscreen.qm_lo && from<=qlscreen.qm_hi) || (to>=qlscreen.qm_lo && to<=qlscreen.qm_hi))
    {
      dfrom=max(qlscreen.qm_lo, from);
      dto=min(qlscreen.qm_hi, to);

      for (i=0; i<sct_size; i++) 
	scrModTable[i]=(i*pagesize+qlscreen.qm_lo<=dto &&
			i*pagesize+qlscreen.qm_lo>=dfrom);
    }
}
 
char **argv;

#ifdef USE_VM
void restart_emulator()
{
  struct itimerval tv;

  tv.it_value.tv_sec=0;
  tv.it_value.tv_usec=0;
  tv.it_interval.tv_sec=0;
  tv.it_interval.tv_usec=0;
  setitimer(ITIMER_REAL,&tv,NULL);
  /*printf("restarting '%s'\n",argv[0]);*/
  execvp(argv[0],argv);
}
#endif

void DbgInfo(void)
{
  int i;

  /* "ssp" is ssp *before* sv-mode was entered (if active now) */
  /* USP is saved value of a7 or meaningless if not in sv-mode */
  printf("DebugInfo: PC=%x, code=%x, SupervisorMode: %s USP=%x SSp=%x A7=%x\n",
	 (Ptr)pc-(Ptr)theROM, code,
	 (supervisor ? "yes" : "no" ),
	 usp,ssp,*sp);
  printf("Register Dump:\t Dn\t\tAn\n");
  for(i=0;i<8;i++)
    printf("%d\t\t%8x\t%8x\n",i,reg[i],aReg[i]);
}


long uqlx_tz;

#if 1
long ux2qltime(long t)
{
  return t+TIME_DIFF+uqlx_tz; /*+qlClock;*//*-timezone+(daylight ? 3600 : 0);*/
}
#endif
long ql2uxtime(long t)
{
  return t-TIME_DIFF-uqlx_tz; /*-qlClock;*/
}
void GetDateTime(w32 *t)
{

  struct timeval tp;
#if 0
  struct tm ltime;
  struct tm gtime;
  time_t ut;
#endif

#ifndef VTIME  

  gettimeofday(&tp,(void*)0);
  *t=ux2qltime(tp.tv_sec)+qlClock;;
#else
  *t=qltime;
#endif
}

int rombreak=0;

int allow_rom_break(int flag)
{
  if (flag<0) return rombreak;

  if (flag)
    {
      uqlx_protect(0,3*32768,QX_RAM);
      rombreak=1;
    }
  else
    {
      uqlx_protect(0,3*32768,QX_ROM);
      rombreak=0; 
    }
  return rombreak;
}

void init_uqlx_tz()
{
  struct tm ltime;
  struct tm gtime;
  time_t ut;

  ut=time(NULL);
  ltime=*localtime(&ut);
  gtime=*gmtime(&ut);

  gtime.tm_isdst=ltime.tm_isdst;
  uqlx_tz=mktime(&ltime)-mktime(&gtime);
}


w32 ReadQlClock(void)
{
  w32 t;
  
  GetDateTime(&t);
  /*  printf("ReadQLClock %d\n",t); */
  
  return t;
}






int impopen(char *name,int flg,int mode)
{
  char buff[PATH_MAX],*p;
  int r,md;

#ifdef __EMX__
  md=mode | O_BINARY;
#else
  md=mode;
#endif
  
  if ((r=open(name,flg,md))!=-1)
    return r;
  
  if(*name == '~')
    {
      char *p = buff;
      strcpy(p, getenv("HOME"));
      strcat(p, name + 1);
      name = p;
    }
  
  return open(name,flg,md);
  
    
  strcpy(buff,IMPL);
  p=buff+strlen(buff);
  if (*(p-1)!='/') strcat(buff,"/");
  strncat(buff,name,PATH_MAX);
  
  return open(buff,flg,md);
}


int load_rom(char *name,w32 addr)
{ 
  struct stat b;
  int r;
  int fd;

  printf("read rom %s at addr %x\n",name,addr);
  
  fd=impopen(name,O_RDONLY,0); 
  if (fd<0) {
    perror("Warning: could not find ROM image' ");
    return 0; }

  fstat(fd,&b);
  if (b.st_size!=16384 && addr!=0) printf("Warning: ROM size of 16K expected, %s is %d\n",
			       name, b.st_size);

  r=read(fd,(Ptr)theROM+addr,b.st_size);
  if (r<0) {
    perror("Warning, could not load ROM \n");
    printf("name %s, addr %x, QDOS origin %x\n",name,addr,theROM);
    return 0; }
  printf("loaded %s \t\tat %x\n",name,addr);
  close(fd);
  
  return r;
}

int scr_planes=2;
int scr_width,scr_height;

int verbose=1;
bctype *RamMap;

#ifndef XAW
extern int shmflag;
#endif


#ifndef XSCREEN
void parse_screen(char *x)
{
  printf("sorry, '-g' option works only with XSCREEN enabled,\ncheck your Makefile\n"); 
}
#endif

#if 0
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
extern char *buf;
extern XImage *image;
extern Display *display;
extern Window imagewin;
extern GC gc;
#endif 


int sct_size;
char *scrModTable, *oldscr ;

static char obuf[BUFSIZ];

void CoreDump()
{
  int fd,r;
  
  fd=open("qlcore",O_RDWR|O_CREAT,0644);
  if (fd<0) perror("coredump failed: read: :");
  if (fd>-1)
    {
      r=write(fd, theROM, 1024*1024);
      if (!r) perror("coredump failed: write: ");
      close(fd);
      if (r)
	printf("memory dump saved as qlcore\n");
    }
}

char *uqlx_version="0.00";

#include "uqlx_cfg.h"

int toggle_hog(int val)
{
  /*printf("toggle_hog, setting to %d\n",val);*/
  if (val<0) return QMD.cpu_hog;
  QMD.cpu_hog=val;
  if(QMD.cpu_hog) min_idle=20000;
  else min_idle=5;
  return QMD.cpu_hog;
}

void usage(char **argv)
{
  printf("UQLX release %s:\n\tusage: %s [options] arguments\n",release,argv[0] );
  printf("\t options:\n"
	 "\t\t -f config_file      : read alternative config file\n"
	 "\t\t -m                  : use greyscale display \n"
	 "\t\t -c                  : display colors [if possible] \n"
	 "\t\t -i                  : start iconified \n"
	 "\t\t -h                  : waste all cpu time available \n"
	 "\t\t -r MEM              : set RAMTOP to this many Kb \n"
	 "\t\t -o romname          : use this ROM \n"
	 "\t\t -b 'boot_cmd'       : define BOOT device with boot_cmd \n"
	 "\t\t -s 'boot_cmd'       :    .. and do scripting \n"
	 "\t\t -g NxM              : define screen size to NxM \n"
	 "\t\t -W window           : reparent root window \n"
	 "\t arguments: available through Superbasic commands\n"
	 );
  exit(0);
}
void SetParams(int ac, char **av)
{
  char *rf;
  char sysrom[200];
  int  rl=0;
  int j,c; 
  int mem=-1, col=-1, hog=-1;
  int gg=0;
  
  setvbuf(stdout,obuf,_IOLBF,BUFSIZ);

  *sysrom=0;
  
#ifndef NO_GETOPT 
  while((c = getopt(ac,av,"f:michr:o:s:b:g:W:p")) != EOF)
  {
    switch(c)
      {
      case 'g':
	gg=0;
	parse_screen(optarg);
	break;
      case 'f':
	{
	  char temp[PATH_MAX];
	  sprintf(temp, "UQLX_CFG=%s", optarg);
	  putenv(temp);
	}
      break;
      case 'o':
	strcpy(sysrom,optarg);
	break;
      case 'm':
	col = 0;
	break;
      case 'c':
	col = 1;
	break;
      case 'r':
	mem = atoi(optarg);
	break;
      case 'h':
	hog = 11;
	break;
      case 'i':
	start_iconic=1;
	break;
      case 'p':
	is_patching=1;
      case 's':
	script=1;
	redir_std=1;
	/* FALLTHRU */
      case 'b':
	{
	  int len;
	  
	  if (optarg && strcmp("",optarg))
	    {
	      ux_boot=2;
	      len=strlen(optarg);
	      ux_bname=malloc(len+2);
	      strncpy(ux_bname,optarg,len);
	      ux_bname[len]=10;
	      ux_bname[len+1]=0;
	    }
	}
	break;
      case 'W':
	pwindow=optarg;
	break;
      default: usage(av);
      }
  }

  UQLX_argc=ac;
  UQLX_argv=av;
  UQLX_optind=optind;

#else
  UQLX_argc=ac;
  UQLX_argv=av;
  UQLX_optind=1;
#endif


  QMParams();
  if (mem>0 && mem<17) mem=mem*1024;

  {
    char *av0=strrchr(av[0],'/');
    av0 = av0 ? av0 : av[0];

    if (*sysrom) strcpy(QMD.sysrom,sysrom);
    else if( strcmp(av0,"qm") )
      {
	if (strstr(av0,"js")) 
	  strcpy(QMD.sysrom,"js_rom");
	if (strstr(av0,"min")) 
	  strcpy(QMD.sysrom,"minerva_rom");
      }
    
    if (gg==0 && strstr(av0,"x"))
      {
	if (strcmp(QMD.sysrom,"minerva_rom"))
	  {
	    strcpy(QMD.sysrom,"minerva_rom");
	    printf("using Minerva ROM\n");
	  }
	if (strstr(av0,"xxx"))
	  parse_screen(QMD.size_xxx);
	else
	  if (strstr(av0,"xx"))
	    parse_screen(QMD.size_xx);
	  else
	    parse_screen(QMD.size_x);
      }
  }
  
  if(mem != -1) QMD.ramtop = mem;
  if(col != -1) QMD.color = col;
  if(hog != -1) QMD.cpu_hog=1;
  
  toggle_hog(QMD.cpu_hog);
  /*  if(QMD.cpu_hog) min_idle=20000;
  else min_idle=5;*/
  
  RTOP=QMD.ramtop*1024; 
  /*  RTOP=RTOP&&(~65535l);*/


}

void uqlxInit()
{
  char *rf;
  int  rl=0;
  void *tbuff;
  int j,c;
  int mem=-1, col=-1, hog=-1;


  rx1=0;rx2=qlscreen.xres-1;ry1=0;ry2=qlscreen.yres-1;finishflag=0;

  printf("*** QL Emulator v%s ***\nrelease %s\n\n",uqlx_version,release);
  tzset();

  /*RTOP=1024*1024;*/

#if defined(VM_SCR) || defined(USE_VM)
  vm_init();
#else
  theROM=malloc(RTOP);
  if (theROM==NULL)
    {
      printf("sorry, not enough memory for a %dK QL\n",RTOP/1024);
      exit(1);
    }
#endif
  /*memset(theROM,0,(128+64)*1024);*/ /* somewhat safer... */

  RamMap=malloc((((1024*1024*1024)/*& ADDR_MASK*/)>>RM_SHIFT)*sizeof(bctype));

  tbuff=malloc(65536*sizeof(void *));
  {
      char roms[PATH_MAX];
      char *p;      

      if(rf=getenv("QL_ROM"))
	  rl=load_rom(rf,0);
      if (!rl)
      {
	  p = (char*)stpcpy(roms, QMD.romdir);
	  if(*(p-1) != '/')
	  {
	      *p++ = '/';
	  }
	  strcpy(p, QMD.sysrom);
	  
	  rl=load_rom(roms ,(w32)0);
	  if (!rl) 
	  {
	      fprintf(stderr,"Could not find qdos ROM image, exiting\n");
	      exit(2);
	  }
      }

      {
	  QMLIST *q;
	  for(q=QMD.romlist;q;q=q->next)
	  {
	      ROMITEM *c = q->udata;
	      strcpy(p, c->romname);
	      rl = load_rom(roms ,(w32) c->romaddr);
	      printf("ROM %s %s loaded at 0x%lx\n", 
		     c->romname, rl ? "" : "NOT", c->romaddr);
	  }
      }
  }


#ifndef XAW
  /*shmflag=0;*/
#endif

  init_uqlx_tz();  
  
#ifdef XAW
  if (script)
    {
      fprintf(stderr,"scriptmode mode not supported with XAW\n");
      script=0;
    }
#endif


  init_signals();

#ifndef XAW
  if (!script && 1)
    {
#ifdef USE_IPC
      init_ipc();
#endif
      HasDialog=InitDialog();
    }
  
#endif

  
  init_iso();

  LoadMainRom();                        /* patch QDOS ROM*/

  if (isMinerva && RTOP>16384*1024) RTOP=16384*1024;
  if (!isMinerva && RTOP>4096*1024) RTOP=4096*1024;

  rtop_hard=RTOP;

  if (isMinerva)
    {
 
      qlscreen.xres=qlscreen.xres & (~(7));
      qlscreen.linel=qlscreen.xres/4;
      qlscreen.qm_len=qlscreen.linel*qlscreen.yres;/*0x8000;*/
      
      qlscreen.qm_lo=128*1024;
      qlscreen.qm_hi=128*1024+qlscreen.qm_len;
#ifdef VERBOSE
      if (qlscreen.qm_len % 32768)
	{
	  printf("current geometry will waste %d bytes for alignment,\n",32768-(qlscreen.qm_len % 32768));
	}
#endif      
      if (qlscreen.qm_len>0x8000)
	{
	  /*qlscreen.qm_hi=RTOP;*/
	  /*qlscreen.qm_lo=qlscreen.qm_hi-qlscreen.qm_len;*/
	  /*RTOP=RTOP-qlscreen.qm_len;*/

	  if ( ((long)RTOP-qlscreen.qm_len)<256*1024+8192)
	    {
	      /*RTOP+=qlscreen.qm_len;*/
	      printf("sorry, not enough RAM for such a big screen\n");
	      goto bsfb;
	    }
	  qlscreen.qm_lo=((RTOP-qlscreen.qm_len)>>15)<<15;    /* RTOP MUST BE 32K aligned.. */
	  qlscreen.qm_hi=qlscreen.qm_lo+qlscreen.qm_len;
	  RTOP=qlscreen.qm_lo;
#if 0
	  printf("RTOP %x, rtop_hard %x, diff %x\n",RTOP,rtop_hard,rtop_hard-RTOP);
	  printf("qm_lo %x, qm_hi %x, qm_len %x\n",qlscreen.qm_lo,qlscreen.qm_hi,qlscreen.qm_len);
#endif
	}
    }
  else  /* JS doesn't handle big screen */
    {
    bsfb:
      qlscreen.linel=128;
      qlscreen.yres=256;
      qlscreen.xres=512;
      
      qlscreen.qm_lo=128*1024;
      qlscreen.qm_hi=128*1024+32*1024;
      qlscreen.qm_len=0x8000;
    }
  
  vm_setscreen();

#ifndef XAW
  if (!script)
    x_screen_open(0);
#endif

  
#ifdef TRACE
  TraceInit();
#endif

  EmulatorTable(tbuff);

  if (!isMinerva)
    {
      table[IPC_CMD_CODE]=UseIPC;        /* installl pseudoops */
      table[IPCR_CMD_CODE]=ReadIPC;
      table[IPCW_CMD_CODE]=WriteIPC;
      table[KEYTRANS_CMD_CODE]=QL_KeyTrans;
      
      table[FSTART_CMD_CODE]=FastStartup;
    }
  

  table[ROMINIT_CMD_CODE]=InitROM;
  table[MDVIO_CMD_CODE]=MdvIO;
  table[MDVO_CMD_CODE]=MdvOpen;
  table[MDVC_CMD_CODE]=MdvClose;
  table[MDVSL_CMD_CODE]=MdvSlaving;
  table[MDVFO_CMD_CODE]=MdvFormat;
  table[POLL_CMD_CODE]=PollCmd;

#if defined(USE_VM) || defined(VM_SCR)
  table[REGEMU_CMD_CODE]=RegEmuCmd;
#endif


#ifdef SERIAL
#ifndef NEWSERIAL
  table[OSERIO_CMD_CODE]=SerIO;
  table[OSERO_CMD_CODE]=SerOpen;
  table[OSERC_CMD_CODE]=SerClose;
#endif
#endif

  table[SCHEDULER_CMD_CODE]=SchedulerCmd;
  if (isMinerva)
    {
      table[MIPC_CMD_CODE]=KbdCmd;
      table[KBENC_CMD_CODE]=KBencCmd;
    }

#if 1
  table[BASEXT_CMD_CODE]=BASEXTCmd;
#endif
  
#ifdef AUTO_BOOT
  table[0x4e43]=btrap3;
#endif
  
#if 0
  WW((uw16 *)((Ptr)theROM+0x4be4),0);     /* avoid booting MDV1_ */
  WW((uw16 *)((Ptr)theROM+0x4bde),0); 
#endif

#ifdef NEW_AREG
  g_reg=reg;
#else
  aReg=reg+8;
  sp=&reg[15];
#endif

  /* setup memory map */

  uqlx_protect(0,(0xffffffff & ADDR_MASK)+1, QX_NONE);
  uqlx_protect(0,RTOP,QX_RAM);

  uqlx_protect(0,64*1024,QX_ROM);                   /* QL ROM       */

  uqlx_protect(64*1024,32768,QX_QXM);               /* hidden emulator add-on */

  uqlx_protect(64*1024+32768,32768, QX_IO);         /* QL I/O       */

#if 0 /* better done elsewhere */
  uqlx_protect(4*32768,32768,QX_SCR);              /* QL video buffer */
#endif

  /*if(qc.romSpace) RamMap[24]=RamMap[25]=65; */    /* 4 expansion ROMs
    from C0000 */

  do_update=0;
  
  init_timers();
  
  InitialSetup();
  
  if (isMinerva)
    {
      reg[1]=RTOP&(~16383) | 1 | 2 | 4 | 16;
      SetPC(0x186);
    }
  
#if defined(VM_SCR) || defined(USE_VM)
  vm_on();
#endif

  QLdone=0;
}

#ifndef XAW
void QLRun(void)
#else
Cond CPUWork(void)
#endif
{
  int scrchange,i;

#ifndef XAW
 exec:
#endif
  
  /* printf("PC=%x\tSP=%x\tSSP=%x\n",(void*)pc-(void*)theROM,*sp,ssp); */
  /*DbgInfo(); */

  ExecuteChunk(1000);
  
  if (do_update && screen_drawable && doscreenflush && !script && !QLdone)
    {
#if defined(VM_SCR) || defined(USE_VM) || defined (EVM_SCR)
      scrchange=0;
      for(i=0;i<sct_size;i++)scrchange=scrchange || scrModTable[i];
      
      if(scrchange)
#else
      if ((displayTo-displayFrom>0 && displayFrom!=0) || 
	  (rx1<=rx2 && ry1<=ry2))
#endif
	{
	  FlushDisplay();
#if !defined(VM_SCR) && !defined(EVM_SCR)
	  displayFrom=0; 
	  displayTo=0; 
#endif	  
	  doscreenflush=0;
	}  
    } 
#ifdef VTIME   
  if ((qlttc--)<=0)
    {
      qlttc=3750;
      qltime++;
    }
  if ((qitc--)<0)
    {
      qitc=3;
      doPoll=1;
      /*FrameInt();*/   
      poll_req++;
      /*dosignal();*/
    }
#endif
  
#ifndef XAW
  if (!QLdone) 
    goto  exec;
  

  cleanup(0);
#else
  return 0;
#endif
}
