/*
 * (c) UQLX - see COPYRIGHT
 */



#ifdef linux
#include <asm/sigcontext.h>
#endif

#ifdef SPARC
#include <sys/ucontext.h>
#include <sys/regset.h>
#endif

#if  defined(VM_SCR) || defined(USE_VM)
#include <signal.h>

typedef struct STATE {
  uw16 code;
  void *pc;
  uw32 save_aReg[8];
 }x_state;

x_state orig_state,res_state;

#if defined(linux) &&defined(m68k)
typedef union {
    struct {
      unsigned long  iaddr;	/* instruction address */
    } fmt2;
    struct {
      unsigned long  effaddr;	/* effective address */
    } fmt3;
    struct {
      unsigned long  effaddr;	/* effective address */
      unsigned long  pc;	/* pc of faulted instr */
    } fmt4;
    struct {
      unsigned long  effaddr;	/* effective address */
      unsigned short ssw;	/* special status word */
      unsigned short wb3s;	/* write back 3 status */
      unsigned short wb2s;	/* write back 2 status */
      unsigned short wb1s;	/* write back 1 status */
      unsigned long  faddr;	/* fault address */
      unsigned long  wb3a;	/* write back 3 address */
      unsigned long  wb3d;	/* write back 3 data */
      unsigned long  wb2a;	/* write back 2 address */
      unsigned long  wb2d;	/* write back 2 data */
      unsigned long  wb1a;	/* write back 1 address */
      unsigned long  wb1dpd0;	/* write back 1 data/push data 0*/
      unsigned long  pd1;	/* push data 1*/
      unsigned long  pd2;	/* push data 2*/
      unsigned long  pd3;	/* push data 3*/
    } fmt7;
    struct {
      unsigned long  iaddr;	/* instruction address */
      unsigned short int1[4];	/* internal registers */
    } fmt9;
    struct {
      unsigned short int1;
      unsigned short ssw;	/* special status word */
      unsigned short isc;	/* instruction stage c */
      unsigned short isb;	/* instruction stage b */
      unsigned long  daddr;	/* data cycle fault address */
      unsigned short int2[2];
      unsigned long  dobuf;	/* data cycle output buffer */
      unsigned short int3[2];
    } fmta;
    struct {
      unsigned short int1;
      unsigned short ssw;	/* special status word */
      unsigned short isc;	/* instruction stage c */
      unsigned short isb;	/* instruction stage b */
      unsigned long  daddr;	/* data cycle fault address */
      unsigned short int2[2];
      unsigned long  dobuf;	/* data cycle output buffer */
      unsigned short int3[4];
      unsigned long  baddr;	/* stage B address */
      unsigned short int4[2];
      unsigned long  dibuf;	/* data cycle input buffer */
      unsigned short int5[3];
      unsigned	   ver : 4;	/* stack frame version # */
      unsigned	   int6:12;
      unsigned short int7[18];
    } fmtb;
} Frame;
#endif /* linux & m68k */


#if 0 /*defined(USE_VM) && defined(GREGS)*/
extern void segv_handler(int , siginfo_t  , ucontext_t *);
#else
#ifdef SPARC
/*extern void segv_handler(int , siginfo_t );*/
extern void segv_handler(int , siginfo_t  , ucontext_t *);
extern void buserr_handler(int , siginfo_t );
#else
#ifdef linux
#ifdef __i486__
void segv_handler(int , struct sigcontext_struct );
void buserr_handler(int , struct sigcontext_struct );
#endif /* i486 */
#ifdef m68k
void buserr_handler(int , struct sigcontext );
void segv_handler(int , int , struct sigcontext *);
#endif /*m68k*/
#else
extern void segv_handler(int , siginfo_t *);
extern void buserr_handler(int , siginfo_t );
#endif
#endif
#endif
extern void vm_on(void);
extern void vm_off(void);
extern void vm_emureg(void);

#else 
#if  defined(USE_VM) 

typedef struct STATE {
  uw16 code;
  void *pc;
  uw32 save_aReg[8];
 }x_state;

x_state orig_state,res_state;


extern long pagesize;
extern char *scrModTable;
extern int sct_size;
extern char * oldscr;


extern void buserr_handler(int  );
extern void segv_handler(int );


extern void vm_on(void);
extern void vm_off(void);
#endif
#endif

